/* REXX */
file='r01-g2.dsk'
targ_drive='a:'

loaded=rxfuncquery('sysloadfuncs')
if loaded=1 then do
  call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
  signal on syntax name NoREXX
  call SysLoadFuncs
end
signal on syntax name Syntax

'@ECHO OFF'

signal on halt name SIGINT
my_q='MQ'

succ=0;

do until succ=1
   q_name=rxqueue('create', my_q)
   if q_name <> my_q then            /* Queue of that name already exists */
                                     /* Left over from a crashed/killed process */
     do
      call rxqueue 'delete', q_name
      call rxqueue 'delete', my_q    /* so we delete it, to be able to recreate it */
      say 'Error creating queue: wrong name ('||q_name||').'
      say 'Trying again...'
     end
   else
     do
      say q_name 'created as queue.'
      succ=1
     end
end

call rxqueue 'set', q_name
call lineout , 'Queue '||q_name||' active. Waiting for data...'
call lineout , ''
call lineout , 'Now spawning loaddskf.exe to write '||file||' to '||translate(targ_drive)
call lineout , 'Reading output from queue '||q_name 

'start /C lddsk.cmd' /* you have to use a 2nd cmd, starting LOADDSKF.EXE */
                     /* directly will fill the queue only when the executable */
                     /* has exited */

call SysSleep 1      /* give lddsk.cmd some time to start */

i=0;k=0;l=0; 
do forever
   if queued() >0 then
   do
     if i=0 then  /*do only once */
     do
       i=1
       text=linein('QUEUE:'); /*discard one empty line */
     end
     text=linein('QUEUE:');
     parse var text first second rest
     if (datatype(second,'W')) | (second = 'percent') then
     do
       if k=0 then /*do only once */
       do
         call lineout , '    1    2    3    4    5    6    7    8    9    10 / 10 written' 
         k=1
       end
       if second='percent' then /*when 100 percent written, word order changes */
       do
         call charout , '#'||'0d0a'x
         l=1;
       end
       else
       do
          if second <> previous then
          do
             previous=second
             h=second//2
             if h = 0 then
             do
/*               call charout , right(second,1)*/ /* Debug */
               call charout , '#'
             end
          end
       end
     end
     else
     do
       if translate(text)='EXIT' then
       do
         signal CLOSE
       end
       if l=0 then call charout , '0d0a'x /* if 100 percent weren't reached, for some reason */
       if length(second) > 0 then
         call lineout , first second rest
     end
   end
   call SysSleep .5 /* needed to prevent CPU-hogging */
end

Syntax:
  say 'Ooops, Error' rc 'in line' sigl':' errortext(rc)
  say sigl':' sourceline(sigl)
  say 'Sorry, pal :-('
  signal close
return

NoRexx:
   say 'Unable to load the REXXUtil functions.  Maybe the REXXUTIL.DLL file'
   say 'is not on the LIBPATH or REXX support is not installed at all'
   say 'on this system. If you''re running Warp4 aka Merlin, there''s something'
   say 'wrong; on Warp3 you may have unselected REXX during install...'
   signal close
return

CLOSE:
SIGINT:
if l=0 then call charout , '0d0a'x /* if 100 percent weren't reached, for some reason */
say 'Received closing message. Cleaning up.'
call rxqueue 'delete', q_name
'pause'
exit

